#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
constant_16 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     IPV6_LEAVE_GROUP IP_MULTICAST_TTL MCAST_JOIN_GROUP */
  /* Offset 4 gives the best switch position.  */
  switch (name[4]) {
  case 'T':
    if (memEQ(name, "MCAST_JOIN_GROUP", 16)) {
    /*                   ^                  */
#ifdef MCAST_JOIN_GROUP
      *iv_return = MCAST_JOIN_GROUP;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'U':
    if (memEQ(name, "IP_MULTICAST_TTL", 16)) {
    /*                   ^                  */
#ifdef IP_MULTICAST_TTL
      *iv_return = IP_MULTICAST_TTL;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case '_':
    if (memEQ(name, "IPV6_LEAVE_GROUP", 16)) {
    /*                   ^                  */
#ifdef IPV6_LEAVE_GROUP
      *iv_return = IPV6_LEAVE_GROUP;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_17 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     IPV6_MULTICAST_IF IP_ADD_MEMBERSHIP IP_MULTICAST_LOOP MCAST_LEAVE_GROUP */
  /* Offset 7 gives the best switch position.  */
  switch (name[7]) {
  case 'E':
    if (memEQ(name, "MCAST_LEAVE_GROUP", 17)) {
    /*                      ^                */
#ifdef MCAST_LEAVE_GROUP
      *iv_return = MCAST_LEAVE_GROUP;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'I':
    if (memEQ(name, "IP_MULTICAST_LOOP", 17)) {
    /*                      ^                */
#ifdef IP_MULTICAST_LOOP
      *iv_return = IP_MULTICAST_LOOP;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'L':
    if (memEQ(name, "IPV6_MULTICAST_IF", 17)) {
    /*                      ^                */
#ifdef IPV6_MULTICAST_IF
      *iv_return = IPV6_MULTICAST_IF;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'M':
    if (memEQ(name, "IP_ADD_MEMBERSHIP", 17)) {
    /*                      ^                */
#ifdef IP_ADD_MEMBERSHIP
      *iv_return = IP_ADD_MEMBERSHIP;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl5.38.0 -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw(IPV6_JOIN_GROUP IPV6_LEAVE_GROUP IPV6_MULTICAST_HOPS
	       IPV6_MULTICAST_IF IPV6_MULTICAST_LOOP IP_ADD_MEMBERSHIP
	       IP_ADD_SOURCE_MEMBERSHIP IP_DROP_MEMBERSHIP
	       IP_DROP_SOURCE_MEMBERSHIP IP_MULTICAST_IF IP_MULTICAST_LOOP
	       IP_MULTICAST_TTL MCAST_BLOCK_SOURCE MCAST_JOIN_GROUP
	       MCAST_JOIN_SOURCE_GROUP MCAST_LEAVE_GROUP
	       MCAST_LEAVE_SOURCE_GROUP MCAST_UNBLOCK_SOURCE));

print constant_types(), "\n"; # macro defs
foreach (C_constant ("Socket::Multicast6", 'constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "\n#### XS Section:\n";
print XS_constant ("Socket::Multicast6", $types);
__END__
   */

  switch (len) {
  case 15:
    /* Names all of length 15.  */
    /* IPV6_JOIN_GROUP IP_MULTICAST_IF */
    /* Offset 5 gives the best switch position.  */
    switch (name[5]) {
    case 'J':
      if (memEQ(name, "IPV6_JOIN_GROUP", 15)) {
      /*                    ^                */
#ifdef IPV6_JOIN_GROUP
        *iv_return = IPV6_JOIN_GROUP;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'L':
      if (memEQ(name, "IP_MULTICAST_IF", 15)) {
      /*                    ^                */
#ifdef IP_MULTICAST_IF
        *iv_return = IP_MULTICAST_IF;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 16:
    return constant_16 (aTHX_ name, iv_return);
    break;
  case 17:
    return constant_17 (aTHX_ name, iv_return);
    break;
  case 18:
    /* Names all of length 18.  */
    /* IP_DROP_MEMBERSHIP MCAST_BLOCK_SOURCE */
    /* Offset 4 gives the best switch position.  */
    switch (name[4]) {
    case 'R':
      if (memEQ(name, "IP_DROP_MEMBERSHIP", 18)) {
      /*                   ^                    */
#ifdef IP_DROP_MEMBERSHIP
        *iv_return = IP_DROP_MEMBERSHIP;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'T':
      if (memEQ(name, "MCAST_BLOCK_SOURCE", 18)) {
      /*                   ^                    */
#ifdef MCAST_BLOCK_SOURCE
        *iv_return = MCAST_BLOCK_SOURCE;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 19:
    /* Names all of length 19.  */
    /* IPV6_MULTICAST_HOPS IPV6_MULTICAST_LOOP */
    /* Offset 17 gives the best switch position.  */
    switch (name[17]) {
    case 'O':
      if (memEQ(name, "IPV6_MULTICAST_LOOP", 19)) {
      /*                                ^        */
#ifdef IPV6_MULTICAST_LOOP
        *iv_return = IPV6_MULTICAST_LOOP;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'P':
      if (memEQ(name, "IPV6_MULTICAST_HOPS", 19)) {
      /*                                ^        */
#ifdef IPV6_MULTICAST_HOPS
        *iv_return = IPV6_MULTICAST_HOPS;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 20:
    if (memEQ(name, "MCAST_UNBLOCK_SOURCE", 20)) {
#ifdef MCAST_UNBLOCK_SOURCE
      *iv_return = MCAST_UNBLOCK_SOURCE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 23:
    if (memEQ(name, "MCAST_JOIN_SOURCE_GROUP", 23)) {
#ifdef MCAST_JOIN_SOURCE_GROUP
      *iv_return = MCAST_JOIN_SOURCE_GROUP;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 24:
    /* Names all of length 24.  */
    /* IP_ADD_SOURCE_MEMBERSHIP MCAST_LEAVE_SOURCE_GROUP */
    /* Offset 9 gives the best switch position.  */
    switch (name[9]) {
    case 'U':
      if (memEQ(name, "IP_ADD_SOURCE_MEMBERSHIP", 24)) {
      /*                        ^                     */
#ifdef IP_ADD_SOURCE_MEMBERSHIP
        *iv_return = IP_ADD_SOURCE_MEMBERSHIP;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    case 'V':
      if (memEQ(name, "MCAST_LEAVE_SOURCE_GROUP", 24)) {
      /*                        ^                     */
#ifdef MCAST_LEAVE_SOURCE_GROUP
        *iv_return = MCAST_LEAVE_SOURCE_GROUP;
        return PERL_constant_ISIV;
#else
        return PERL_constant_NOTDEF;
#endif
      }
      break;
    }
    break;
  case 25:
    if (memEQ(name, "IP_DROP_SOURCE_MEMBERSHIP", 25)) {
#ifdef IP_DROP_SOURCE_MEMBERSHIP
      *iv_return = IP_DROP_SOURCE_MEMBERSHIP;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

